	.cpu	68000

	.include scsi_func.inc

		.xdef	_S_VERIFY

		.xref	message
		.xref	status

;-----------------------------------------------------
;	VERIFY
;-----------------------------------------------------
		.offset	4
verify_lba:	.ds.l	1
verify_blen:	.ds.l	1
verify_id:	.ds.l	1
		.text
verify_cdb:	.dc.b	$2F
		.dcb.b	9,0
_S_VERIFY:
		lea	(verify_cdb,pc),a1
		move.l	(verify_lba,sp),(2,a1)
		move.l	(verify_blen,sp),d2
		move.b	d2,(8,a1)
		lsr.w	#8,d2
		move.b	d2,(7,a1)
		move.l	d4,d2
		move.l	(verify_id,sp),d4
		move.l	d4,d1
		swap	d1
		lsl.b	#5,d1
		move.b	d1,(1,a1)

		SCSI	$01		;S_SELECT
		tst.l	d0
		bne	verify_error

		SCSI	$03		;S_CMDOUT
		tst.l	d0
		bmi	verify_error

		lea	(status+1,pc),a1
		SCSI	$06		;S_STSIN
		tst.l	d0
		bne	verify_error
		subq.l	#2,a1
		SCSI	$07		;S_MSGIN
		tst.l	d0
		bne	verify_error

		move.l	(-1,a1),d0

@@:		move.l	d2,d4
		rts

verify_error:	moveq	#-1,d0
		bra	@b

	.end
